---Made By @poc@lypse.

---For ls-modteam-France

renault = {};

function renault.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Steerable, specializations);
end;

function renault:load(xmlFile)
          print("'lua loaded '" );


	self.brakeForce = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.brakeForce"), 10);
    self.controlpath = Utils.getFilename("renaultcontrol.png", self.baseDirectory);
    self.hudrenaultPoxX = 0.01;
    self.hudrenaultPoxY = 1-0.204;
    self.hudrenaultWidth = 0.240;
    self.hudrenaultHeight = 0.240;
    self.hudrenaultPoxX = 0.75;
    self.hudrenaultPoxY = 0.60
    self.hudrenaultOverlay = Overlay:new("hudrenaultcontrol", self.controlpath, self.hudrenaultPoxX, self.hudrenaultPoxY, self.hudrenaultWidth, self.hudrenaultHeight);
   
    self.numWorklights = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.worklights#count"), 0);
    self.worklights = {};
    for i=1, self.numWorklights do
        local worklightnamei = string.format("vehicle.worklights.worklight" .. "%d", i);
        self.worklights[i] = Utils.indexToObject(self.rootNode, getXMLInt(xmlFile, worklightnamei .. "#index"));
        setVisibility(self.worklights[i], false);
    end;

   
	       
    self.numjumWheels = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.jumWheels#count"), 0);
    self.jumWheels = {};
    for i=1, self.numjumWheels do
        local jumWheelnamei = string.format("vehicle.jumWheels.jumWheel" .. "%d", i);
        self.jumWheels[i] = Utils.indexToObject(self.rootNode, getXMLInt(xmlFile, jumWheelnamei .. "#index"));
        setVisibility(self.jumWheels[i], false);
    end;
    
   
    
    self.rundumleuchtenAnz = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.rundumleuchten#count"),0);
    self.rundumleuchtenKey = getXMLString(xmlFile, "vehicle.rundumleuchten#key");
    self.rundumleuchtenAn = false;
    self.rundumleuchten = {};
    for i=1, self.rundumleuchtenAnz do
        local objname = string.format("vehicle.rundumleuchten.light" .. "%d",i);
        self.rundumleuchten[i] = {};
        self.rundumleuchten[i].rotNode = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, objname .. "#rotNode"));
        self.rundumleuchten[i].light = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, objname .. "#light"));
        self.rundumleuchten[i].source = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, objname .. "#lightsource"));
        self.rundumleuchten[i].speed = Utils.getNoNil(getXMLInt(xmlFile,  objname .. "#rotSpeed"), 1)/1000;
        self.rundumleuchten[i].emit = Utils.getNoNil(getXMLBool(xmlFile, objname .. "#emitLight"), true);
        if not self.rundumleuchten[i].emit and self.rundumleuchten[i].source ~= nil then
           setVisibility(self.rundumleuchten[i].source, false);
        end;
    end;
    self.motorBrakeForce = self.motor.brakeForce;
	self.brakeOn = false;
    self.revLimit = 100;
    self.worklightsActive = false;
    self.travailsActive = false;  
    self.jumWheelsActive = false;

     self.bcActive = false;
end;

function renault:delete()
end;

function renault:mouseEvent(posX, posY, isDown, isUp, button)
end;

function renault:keyEvent(unicode, sym, modifier, isDown)
    
    
    if isDown and sym == 48 then -- Key: 0
		self.bcActive = not self.bcActive;
    end;    

    if isDown and sym == Input.KEY_8 then
		self.worklightsActive = not self.worklightsActive;
	end;   
    

    if isDown and sym == Input.KEY_9 then
		self.jumWheelsActive = not self.jumWheelsActive;      
	end;
   
    if self.isEntered then
      if self.rundumleuchtenKey ~= nil then
         if isDown and sym == Input[self.rundumleuchtenKey] then
           self.rundumleuchtenAn = not self.rundumleuchtenAn;
           for i=1, self.rundumleuchtenAnz do
             setVisibility(self.rundumleuchten[i].light, self.rundumleuchtenAn);
           end;
         end;
      end;
    end;
end;

 
function renault:update(dt)
  

   
  if self.isEntered then
       
        if self.worklightsActive then
		   for i=1, self.numWorklights do
			local worklight = self.worklights[i];
			setVisibility(worklight, self.worklightsActive);
		   end;
	       else
		   for i=1, self.numWorklights do
			local worklight = self.worklights[i];
			setVisibility(worklight, self.worklightsActive, false);
		   end;
	    end;
              
        
        if not self.jumWheelsActive then
			for i=1, self.numjumWheels do
				local jumWheel = self.jumWheels[i];
				setVisibility(jumWheel, self.jumWheelsActive);
			end;
		else
			for i=1, self.numjumWheels do
				local jumWheel = self.jumWheels[i];
				setVisibility(jumWheel, self.jumWheelsActive, false);
			end;
		end;
    end;
    
  if self.isEntered then
    if self.rundumleuchtenAnz > 0 then
      if self.rundumleuchtenAn then
        for i=1, self.rundumleuchtenAnz do
          rotate(self.rundumleuchten[i].rotNode, 0, dt*self.rundumleuchten[i].speed, 0);
        end;
      end;
    end;
  end;
  
 
  
end;

function renault:onLeave()
    self.worklightsActive = false;
    self.jumWheelsActive = false; 
    self.rundumleuchtenAn = false;
     for i=1, self.rundumleuchtenAnz do
       setVisibility(self.rundumleuchten[i].light, self.rundumleuchtenAn);
      end;
   
 
end;
 

function renault:draw()
   if self.hudrenaultOverlay ~= nil then
       if self.bcActive then
        self.hudrenaultOverlay:render();
       end;  
   end;
		if self.bcActive then	
			g_currentMission:addExtraPrintText("Taste 0: Hilfe AN");
		else
			g_currentMission:addExtraPrintText("Taste 0: Hilfe Aus");
		end;
 
end;